#
#(C) 2008-2011 Advanced Micro Devices, Inc. All Rights Reserved.
#  
#  This file is part of AMD LibM 3.0.
#  
#  AMD LibM 3.0 is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#  
#  AMD LibM 3.0 is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with AMD LibM 3.0.  If not, see
#  <http://www.gnu.org/licenses/>.
#  
#

#include "fn_macros.h"
#define fname FN_PROTOTYPE_BDOZR(cosf)
#define fname_special   _cosf_special@PLT

#include "trig_func.h"


.equ    r,    0x30                               # pointer to r for amd_remainder_piby2
.equ    rr,   0x40                               # pointer to rr for amd_remainder_piby2
.equ    region,    0x50                               # pointer to region for amd_remainder_piby2
.equ    ret_addr, 0x60
.equ   stack_size, 0x88



#ifdef __ELF__
.section .note.GNU-stack,"",@progbits
#endif

.text
.align 32
.p2align 4,,15
.globl fname
.type fname,@function
fname:

    	sub     $stack_size, %rsp
cosf_early_exit_s:

    MOVD  %xmm0,%eax
    MOV   %eax,%r9d
    MOV   .L__inf_mask_32(%rip),%r8d
    AND   %r8d,%eax
    CMP   %r8d,%eax
    JZ    cosf_naninf

    VCVTPS2PD    %xmm0,%xmm0
    MOVD  %xmm0,%r9
    AND    .L__sign_mask(%rip),%r9            #clear sign



cosf_early_exit_s_1:
    CMP   .L_mask_3fe(%rip),%r9
    JG    range_reduce
    CMP   .L_mask_3f8(%rip),%r9
    JGE    compute_cosf_pyby_4
    CMP   .L_mask_3f2(%rip),%r9
    JGE   compute_1_xx_5

    VMOVQ .L_one(%rip),%xmm0
    JMP return_cosf_s

compute_1_xx_5:

    VMULSD    .L_point_five(%rip),%xmm0,%xmm1                          #
    VFNMADDSD    .L_one(%rip),%xmm0,%xmm1,%xmm0         # %xmm9 1.0 - x*x*(double2)0.5#
    JMP return_cosf_s

compute_cosf_pyby_4:
    cos_piby4_sf
    JMP    return_cosf_s

range_reduce:

    VMOVQ   %r9,%xmm0                                # %r9 x with the sign cleared
    cmp  .L_e_5(%rip),%r9
    JGE  cosf_remainder_piby2

#cosf_range_e_5_s:
    range_e_5_sf
    JMP cosf_exit_s

cosf_remainder_piby2:
    call_remainder_piby2_f

cosf_exit_s:

    VANDPD    .L_int_one(%rip),%xmm11, %xmm3
    VPCOMEQUQ .L_int_one(%rip), %xmm3,%xmm3
    VMOVDDUP    %xmm3,%xmm3
    VPTEST    %xmm3,%xmm3
    JZ    cosf_piby4_compute

#sinf_piby4_compute:
    sin_piby4_sf
    JMP cosf_exit_s_1

cosf_piby4_compute:
    cos_piby4_sf

cosf_exit_s_1:

    VPCOMEQUQ   .L_int_one(%rip),%xmm11, %xmm1
    VPCOMEQUQ   .L_int_two(%rip),%xmm11,%xmm2
    VORPD    %xmm2,%xmm1,%xmm3

    VANDPD    .L_signbit(%rip),%xmm3,%xmm3
    VXORPD    %xmm0,%xmm3,%xmm0

return_cosf_s:

    VCVTPD2PS    %xmm0,%xmm0
    add      $stack_size, %rsp
    ret

cosf_naninf:
    call    fname_special
    add      $stack_size, %rsp
    ret
