#
#(C) 2008-2011 Advanced Micro Devices, Inc. All Rights Reserved.
#  
#  This file is part of AMD LibM 3.0.
#  
#  AMD LibM 3.0 is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#  
#  AMD LibM 3.0 is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with AMD LibM 3.0.  If not, see
#  <http://www.gnu.org/licenses/>.
#  
#

#include "fn_macros.h"
#define fname FN_PROTOTYPE_BDOZR(tan)
#define fname_special   _tan_special@PLT
#define fname_special_underflow _sin_special_underflow@PLT
#include "trig_func.h"


.equ    r,    0x30                               # pointer to r for amd_remainder_piby2
.equ    rr,   0x40                               # pointer to rr for amd_remainder_piby2
.equ    region,    0x50                               # pointer to region for amd_remainder_piby2
.equ    ret_addr, 0x60
.equ    store_input, 0x70
.equ   stack_size, 0x88



#ifdef __ELF__
.section .note.GNU-stack,"",@progbits
#endif

.text
.align 32
.p2align 4,,15
.globl fname
.type fname,@function
fname:

    	sub     $stack_size, %rsp

tan_early_exit_s:

    MOVD  %xmm0,%rax
    MOV   %rax,%r9
    MOV   .L__inf_mask_64(%rip),%r8
    AND   %r8,%rax
    CMP   %r8,%rax
    JZ    tan_naninf
    AND   .L__sign_mask(%rip),%r9                   #clear sign
    VMOVUPD    %xmm0,store_input(%rsp)


tan_early_exit_s_1:

    CMP   .L_mask_3fe(%rip),%r9
    JG    range_reduce
    CMP  .L_mask_3f2(%rip),%r9
    JGE   compute_tan_pyby_4
    CMP   .L_mask_3e4(%rip),%r9
    JGE   compute_x_xxx_0_333


##  Additional code to raise underflow exception
   xor      %rax,%rax
   cmp      %rax,%r9
   je      return_tan_s
   call     fname_special_underflow
   JMP return_tan_s

compute_x_xxx_0_333:

    VMULSD    %xmm0,%xmm0,%xmm1                         #
    VMULSD    %xmm1,%xmm0,%xmm1                         # %xmm1 x3
    VFMADDSD  %xmm0,.L_point_333(%rip),%xmm1,%xmm0         #  x - x*x*x*0.166666666666666666#
    JMP return_tan_s

compute_tan_pyby_4:
    tan_piby4_s_zero
    JMP    return_tan_s


range_reduce:

   VMOVQ   %r9,%xmm0                                # %r9 x with the sign cleared
    cmp  .L_e_5(%rip),%r9
    JGE  tan_remainder_piby2

#tan_range_e_5_s:
	range_e_5_s
	JMP tan_exit_s

tan_remainder_piby2:
	call_remainder_piby2
	JMP tan_exit_s

tan_exit_s:

	VANDPD	.L_int_one(%rip),%xmm11,%xmm3
	tan_piby4_s

tan_exit_s_1:

	VMOVAPD	 store_input(%rsp),%xmm1
	VANDPD	.L_signbit(%rip),%xmm1,%xmm1
	VXORPD	%xmm1,%xmm0,%xmm0

return_tan_s:

   	add      $stack_size, %rsp
	ret


tan_naninf:
    call    fname_special
    add      $stack_size, %rsp
    ret
